## Collection of operators implemented as commands on top of expr.
## These can often be cleaner and easier to read than the actual [expr] 
## command, especially for short calculations.
##
## Authors: Kristoffer Lawson, setok@fishpool.com
## $Header: /cvs/codebase/tcl/easyOpers.tcl,v 1.1 2003/05/05 23:31:59 setok Exp $


package provide fishpool.easyOps 0.1


namespace eval easyOps {

namespace export *


proc + {r args} {
    foreach operand $args {
	set r [expr {$r + $operand}]
    }

    return $r
}


proc - {r args} {
    foreach operand $args {
	set r [expr {$r - $operand}]
    }

    return $r
}


proc * {r args} {
    foreach operand $args {
	set r [expr {$r * $operand}]
    }

    return $r
}


proc / {r args} {
    foreach operand $args {
	set r [expr {$r / $operand}]
    }

    return $r
}


proc & {r args} {
    foreach operand $args {
	set r [expr {$r & $operand}]
    }

    return $r
}


proc >> {r bits} {
    return [expr {$r >> $bits}]
}


proc int {num} {
    return [expr {int($num)}]
}


}  ;# End of easyOps namespace